/*
  Copyright 2010 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GENERATEDIALOG_H
#define GENERATEDIALOG_H

#include <list>

#include <wx/wx.h>
#include <wx/choice.h>
#include <wx/textctrl.h>
#include <controller/KissCount.h>
#include "wxUI.h"
#include <model/model.h>

class wxUI;
class KissCount;

class GenerateDialog : public wxDialog
{
public: 
    GenerateDialog(KissCount* kiss, wxUI *parent, int month, int year);
  
    void OnYearFromChange(wxCommandEvent& event);
    void OnYearToChange(wxCommandEvent& event);
    void OnOK(wxCommandEvent& event);
    void OnCancel(wxCommandEvent& event);

private:
    KissCount* _kiss;
    wxUI* _wxUI;
    wxChoice* _yearFrom, *_monthFrom, *_yearTo, *_monthTo;
    std::map<int, std::vector<int> > _ops;

    DECLARE_EVENT_TABLE();

};
#endif
